#include "RaptorQ/v1/Shared_Computation/Operation_Vector_Store.hpp"
#include "RaptorQ/v1/caches.hpp"
#include <memory>
#include <utility>
#include <algorithm>
#include <iostream>
#include <chrono>
#include <cstdlib>
#include "catch2/catch.hpp"

using namespace RaptorQ__v1::Impl;
using OPSVec = std::deque<Operation>;

TEST_CASE( "Basic OVS", "[Operation vector store]" )
{
    Matrix A = Matrix(4, 4);
    for (int i = 0;i < 4; i++)
        for (int j = 0;j < 4; j++)
            A(i, j) = 2;
    bool result = OVS<OPSVec>::get()->apply(A, 977);
    REQUIRE( result == false );
    REQUIRE( OVS<OPSVec>::get()->available(977) == false );

    OPSVec ops;
    ops.emplace_back (Operation::_t::ADD_MUL, 0, 1, Octet(2));
    OVS<OPSVec>::get()->add(std::move(ops), 977);

    REQUIRE( A(0, 0) == 2 );

    result = OVS<OPSVec>::get()->apply(A, 977);
    REQUIRE( result == true );
    REQUIRE( OVS<OPSVec>::get()->available(977) == true );
    REQUIRE( A(0, 0) == 6 );
}
